package especialista;

import java.util.*;
import javax.naming.Context;
import javax.rmi.PortableRemoteObject;

public class CartClient {

   public static void main(String[] args) {
      Context jndiContext = null;

      try {
         jndiContext = getInitialContext();
         Object objref = jndiContext.lookup("CartBean");

         CartHome home =
            (CartHome) PortableRemoteObject.narrow(
               objref,
               CartHome.class);

         Cart shoppingCart = home.create("Duke DeEarl", "123");

         shoppingCart.addBook("Head First EJB");
         shoppingCart.addBook("EJB Design Patterns");
         shoppingCart.addBook("Understanding .NET");

         Collection bookList = shoppingCart.getBookTitles();

         Iterator it = bookList.iterator();
         while (it.hasNext()) {
            String title = (String) it.next();
            System.out.println(title);
         }

         //          shoppingCart.removeBook("Alice in Wonderland");
         //          shoppingCart.remove();

         shoppingCart.removeBook("Understanding .NET");

         System.out.println("\nHe borrado Understanding .NET");
         System.out.println();
         System.out.println("Ahora tengo:");

         bookList = shoppingCart.getBookTitles();
         Collection isbnList = shoppingCart.getBookIsbns();
         
         it = bookList.iterator();
         Iterator itIsbn = isbnList.iterator();
         while (it.hasNext()) {
            String title = (String) it.next();
			String isbn = (String) itIsbn.next();
            System.out.println(title+"--"+isbn);
         }

         System.out.println(
            "El coste del pedido es de "
               + shoppingCart.getOrderPrice()
               + " euros");

         shoppingCart.remove();
         System.exit(0);
         
      } catch (Exception ex) {
         System.err.println("Caught an unexpected exception!");
         ex.printStackTrace();
         System.exit(1);
      }

      // pruebo el entity bean

   }

   public static Context getInitialContext()
      throws javax.naming.NamingException {
      Properties p = new Properties();
      p.put(
         Context.INITIAL_CONTEXT_FACTORY,
         "weblogic.jndi.WLInitialContextFactory");
      p.put(Context.PROVIDER_URL, "t3://localhost:7001");
      return new javax.naming.InitialContext(p);
   }
}
