package especialista;

import java.util.Collection;
import java.util.Iterator;

import javax.ejb.CreateException;
import javax.ejb.*;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class BookFinderBean implements SessionBean {

   private static BookHome bookHome = null;
   private static InitialContext ic = null;
	
   public void setSessionContext(SessionContext arg0) { }
   public void ejbRemove() { }
   public void ejbActivate()   { }
   public void ejbPassivate() { }

   public void ejbCreate() throws CreateException {
      if (bookHome == null) {
         try {
            ic = new InitialContext();     	
            Object objref = ic.lookup("BookBean");
            bookHome =
               (BookHome) PortableRemoteObject.narrow(
                  objref,
                  BookHome.class);
         } catch (Exception ex) {
            throw new CreateException(
               "Excepcion al crear el bookHome: " + ex.getMessage());
            }
      }
   }
   
   public BookVO getBook(String title)  {
   	  Book bestBook = null;
      BookVO bookVO = null;
      
      try {
      	 Collection books = bookHome.findByTitle(title);
      	 Iterator it = books.iterator();
      	 double bestPrice = 10000;
      	 while (it.hasNext()) {
      	 	Book bookIterator = (Book) it.next();
      	 	if (bookIterator.getPrice() < bestPrice)
      	 	   bestBook = bookIterator;
      	 }
      	 
      } catch (Exception e) {
         throw new RuntimeException (
            "Excepcion al intentar obtener "
               + title
               + "\n"
               + "Excepcion: "
               + e.getMessage());
      }
      try {
      	bookVO = new BookVO(bestBook.getIsbn(),bestBook.getTitle(),bestBook.getPrice());
      } catch (Exception ex) {
      	   throw new RuntimeException("Excepcion al buscar un libro: " + ex.getMessage());
      }
      return bookVO;
   }
}
